#include <u.h>
#include <libc.h>
#include <a.out.h>
#include <dynld.h>

#define	CHK(i,ntab)	if((unsigned)(i)>=(ntab))return "bad relocation index"

long
dynmagic(void)
{
	return DYN_MAGIC | I_MAGIC;
}

char*
dynreloc(uchar *b, ulong p, int m, Dynsym **tab, int ntab)
{
	int i;
	ulong v, *pp;

	p += (ulong)b;
	pp = (ulong*)p;
	v = *pp;
	switch(m){
	case 0:
		v += (ulong)b;
		break;
	case 1:
		i = v>>22;
		v &= 0x3fffff;
		CHK(i, ntab);
		v += tab[i]->addr;
		break;
	case 2:
		i = v>>22;
		CHK(i, ntab);
		v = tab[i]->addr -p-4;
		break;
	default:
		return "bad relocation mode";
	}
	*pp = v;
	return nil;
}

char *
crack_dynrel(uchar *b, Dynrel *dr)
{
	int i;
	ulong p, v, *pp;

	p = dr->offset;
	p += (ulong)b;
	pp = (ulong*)p;
	v = *pp;
	switch(dr->mode){
	case 0:
		dr->reloc_index = -1;
		dr->reloc_offset = v;
		break;
	case 1:
		i = v>>22;
		v &= 0x3fffff;
		dr->reloc_index = i;
		dr->reloc_offset = v;
		break;
	case 2:
		i = v>>22;
		dr->reloc_index = i;
		dr->reloc_offset = -p - 4;
		break;
	default:
		return "bad relocation mode";
	}
	return nil;
}