/*
 * So, having failed to emulate the import table in C, we are back
 * to scanning our export table.  Hooray.
 */

#include "plan9/includeonce.h"
#include "plan9/dyngen-helpers-plan9.h"

void plan9_dyngen_init(void)
{
	int i;
	int exportsize = dyntabsize(_exporttab);

	for(i = 0; i < dyngen_nimport; i++)
	{
		if(dyngen_itab_elts[i].abuse == 0)
		{
			Dynsym *exportentry =
				dynfindsym(
							dyngen_itab_elts[i].d.name,
							_exporttab,
							exportsize
				);
			if(exportentry->sig != dyngen_itab_elts[i].d.sig){
				char buf[100];
				snprint(buf, 100, "Signature mismatch for symbol %s\n",
						dyngen_itab_elts[i].d.name);
				exits(buf);
			}

			dyngen_itab_elts[i].d.addr = exportentry->addr;
		}
	}
}
