#ifndef _PLAN9_INCLUDE_ONCE_H_
#define _PLAN9_INCLUDE_ONCE_H_

#include <u.h>
#include <libc.h>
#include <dynld.h>
#include <stdio.h>

#ifndef NULL
#define NULL nil
#endif

typedef u8int uint8_t;
typedef u16int uint16_t;
typedef u32int uint32_t;
typedef u64int uint64_t;

    /* XXX: These should be in u.h.  Seriously, WTF?! */
typedef char int8_t;
typedef short int16_t;
typedef long int32_t;
typedef long long int64_t;

typedef ulong size_t;
typedef long ssize_t;

#define snprintf snprint

    /* XXX */
#define PRIx64 "%ullx"

    /* The FPU stuff is messy, so we just override things here */
#if defined(PLAN9_STATICS_EXPORT) || defined(PLAN9_STATICS_PROTOS)
#define INLINE inline
#endif

    /* Compatibility macros */
#define _exit(x) { char buf[20]; snprint(buf, 20, "_exit: %d", x); exits(buf); }
#define exit(x) { char buf[20]; snprint(buf, 20, "exit: %d", x); exits(buf); }

    /* Some components of QEMU use errno internally.  We don't
     * actually _need_ the real errno's, so we define some names
     * ourselves.
     *
     * QEMU assumes positive values for these.
     */
enum fake_errno {
    EIO = 1,
    EINVAL = 2,
};
#endif

